////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL SaveScheduleToDataBase(void)
{
    int LocalLoop     = 0;
    char *ColumbName  = NULL;

    _DataDaseSystem DBS;

	InitializeDBS(&DBS, 25, MaxSchedules + 1);

    ColumbName = "NonSchedInfo";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "Name";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Filename";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Description";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "SQLServer";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Database";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "DBDriver";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Username";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Password";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "IsTrusted";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "WeekDays";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "IncrementHour";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "IncrementMinute";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "BackupWindowTimeBegin";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "BackupWindowTimeEnd";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "StartOnceTime";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "LastRunTime";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "LastRunDate";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "ScheduleID";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "Active";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));
    ColumbName = "OnlyRunOnce";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    ColumbName = "Reserved";
    AddColumb(&DBS, ColumbName, strlen(ColumbName));

    AddEntryByColumbName(&DBS, "NonSchedInfo", (char *) &NumberOfSetSchedules, sizeof(int));
    AddEntryByColumbName(&DBS, "NonSchedInfo", (char *) &CurrentScheduleID, sizeof(DWORD));

    while(LocalLoop < MaxSchedules)
    {
        if(BT[LocalLoop].ScheduleSet == TRUE)
        {
            AddEntryByColumbName(&DBS, "Name", BT[LocalLoop].Name, strlen(BT[LocalLoop].Name));
            AddEntryByColumbName(&DBS, "Filename", BT[LocalLoop].Filename, strlen(BT[LocalLoop].Filename));
            AddEntryByColumbName(&DBS, "Description", BT[LocalLoop].Description, strlen(BT[LocalLoop].Description));

            AddEntryByColumbName(&DBS, "SQLServer", BT[LocalLoop].SQLServer, strlen(BT[LocalLoop].SQLServer));
            AddEntryByColumbName(&DBS, "Database", BT[LocalLoop].Database, strlen(BT[LocalLoop].Database));
            AddEntryByColumbName(&DBS, "DBDriver", BT[LocalLoop].DBDriver, strlen(BT[LocalLoop].DBDriver));
            AddEntryByColumbName(&DBS, "Username", BT[LocalLoop].Username, strlen(BT[LocalLoop].Username));
            AddEntryByColumbName(&DBS, "Password", BT[LocalLoop].Password, strlen(BT[LocalLoop].Password));
            AddEntryByColumbName(&DBS, "IsTrusted", (char *) &BT[LocalLoop].IsTrusted, sizeof(BOOL));

            AddEntryByColumbName(&DBS, "WeekDays", (char *) &BT[LocalLoop].WeekDays, sizeof(BT[LocalLoop].WeekDays));

            AddEntryByColumbName(&DBS, "ScheduleID", (char *) &BT[LocalLoop].ScheduleID, sizeof(DWORD));

            AddEntryByColumbName(&DBS, "BackupWindowTimeBegin", (char *) &BT[LocalLoop].BackupWindowTimeBegin, sizeof(DWORD));
            AddEntryByColumbName(&DBS, "BackupWindowTimeEnd", (char *) &BT[LocalLoop].BackupWindowTimeEnd, sizeof(DWORD));
            AddEntryByColumbName(&DBS, "StartOnceTime", (char *) &BT[LocalLoop].StartOnceTime, sizeof(DWORD));

            AddEntryByColumbName(&DBS, "LastRunTime", (char *) &BT[LocalLoop].LastRunTime, sizeof(DWORD));
            AddEntryByColumbName(&DBS, "LastRunDate", (char *) &BT[LocalLoop].LastRunDate, sizeof(DWORD));

            AddEntryByColumbName(&DBS, "IncrementHour", (char *) &BT[LocalLoop].IncrementHour, sizeof(WORD));
            AddEntryByColumbName(&DBS, "IncrementMinute", (char *) &BT[LocalLoop].IncrementMinute, sizeof(WORD));

            AddEntryByColumbName(&DBS, "Active", (char *) &BT[LocalLoop].Active, sizeof(BOOL));
            AddEntryByColumbName(&DBS, "OnlyRunOnce", (char *) &BT[LocalLoop].OnlyRunOnce, sizeof(BOOL));
        }

        LocalLoop++;
    }

    if(WriteDBFile(&DBS, SavedDataFile) == FALSE)
        return FALSE;

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL ReadDataBaseToSchedule(void)
{
    _DataDaseSystem DBS;
    int LocalLoop = 0;

    if(ReadDBFile(&DBS, SavedDataFile) == FALSE)
        return FALSE;

    RetreiveDataByColumbName(&DBS, "NonSchedInfo", 0, (char *) &NumberOfSetSchedules);
    RetreiveDataByColumbName(&DBS, "NonSchedInfo", 1, (char *) &CurrentScheduleID);

    while(LocalLoop < NumberOfSetSchedules)
    {
        BT[LocalLoop].Name        = (char *) calloc(1024, 1);
        BT[LocalLoop].Description = (char *) calloc(256, 1);
        BT[LocalLoop].Filename    = (char *) calloc(256, 1);

        BT[LocalLoop].SQLServer = (char *) calloc(256, 1);
        BT[LocalLoop].Database  = (char *) calloc(256, 1);
        BT[LocalLoop].DBDriver  = (char *) calloc(256, 1);
        BT[LocalLoop].Username  = (char *) calloc(256, 1);
        BT[LocalLoop].Password  = (char *) calloc(256, 1);


        RetreiveDataByColumbName(&DBS, "Name", LocalLoop, BT[LocalLoop].Name);
        RetreiveDataByColumbName(&DBS, "Description", LocalLoop, BT[LocalLoop].Description);
        RetreiveDataByColumbName(&DBS, "Filename", LocalLoop, BT[LocalLoop].Filename);

        RetreiveDataByColumbName(&DBS, "SQLServer", LocalLoop, BT[LocalLoop].SQLServer);
        RetreiveDataByColumbName(&DBS, "Database", LocalLoop, BT[LocalLoop].Database);
        RetreiveDataByColumbName(&DBS, "DBDriver", LocalLoop, BT[LocalLoop].DBDriver);
        RetreiveDataByColumbName(&DBS, "Username", LocalLoop, BT[LocalLoop].Username);
        RetreiveDataByColumbName(&DBS, "Password", LocalLoop, BT[LocalLoop].Password);
        RetreiveDataByColumbName(&DBS, "IsTrusted", LocalLoop, (char *) &BT[LocalLoop].IsTrusted);

        RetreiveDataByColumbName(&DBS, "WeekDays", LocalLoop, (char *) &BT[LocalLoop].WeekDays);

        RetreiveDataByColumbName(&DBS, "ScheduleID", LocalLoop, (char *) &BT[LocalLoop].ScheduleID);

        RetreiveDataByColumbName(&DBS, "BackupWindowTimeBegin", LocalLoop, (char *) &BT[LocalLoop].BackupWindowTimeBegin);
        RetreiveDataByColumbName(&DBS, "BackupWindowTimeEnd", LocalLoop, (char *) &BT[LocalLoop].BackupWindowTimeEnd);
        RetreiveDataByColumbName(&DBS, "StartOnceTime", LocalLoop, (char *) &BT[LocalLoop].StartOnceTime);

        RetreiveDataByColumbName(&DBS, "IncrementHour", LocalLoop, (char *) &BT[LocalLoop].IncrementHour);
        RetreiveDataByColumbName(&DBS, "IncrementMinute", LocalLoop, (char *) &BT[LocalLoop].IncrementMinute);

        RetreiveDataByColumbName(&DBS, "LastRunTime", LocalLoop, (char *) &BT[LocalLoop].LastRunTime);
        RetreiveDataByColumbName(&DBS, "LastRunDate", LocalLoop, (char *) &BT[LocalLoop].LastRunDate);

        RetreiveDataByColumbName(&DBS, "Active", LocalLoop, (char *) &BT[LocalLoop].Active);
        RetreiveDataByColumbName(&DBS, "OnlyRunOnce", LocalLoop, (char *) &BT[LocalLoop].OnlyRunOnce);

        BT[LocalLoop].ScheduleSet = TRUE;

        LocalLoop++;
    }

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

